////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO
//
////////////////////////
//  РЕДАКТОР и ИСПОЛНИТЕЛЬ ЭФФЕКТОВ ДЛЯ СВЕТОДИОДНОГО КУБА 6*6*6 (ВАРИАЦИЯ С ПРИЛОЖЕНИЕМ НА СМАРТФОН)

#include <ps2.h>//библиотеку подключаем для работы с мышью по протоколу ps/2
#include <SPI.h>
#include <SD.h>
#include <LedControlSPI.h>//вариация библиотеки LedControl (переименована),использующая аппаратный SPI 
// https://github.com/jacken/LedControl_HW_SPI
///////////////////////////////////////////

const uint8_t PIN_CS = 10;//CS-10;SCK,CLK-13;MISO-12;MOSI-11 подключение выводов платы                         
File myFile;     
///////////////////////////////////////////
#define k1 6
 int x=0;int y=0;int z=0;
 int n=150;//единица длительности переключений в мс
 const int N=650;//размер массива
 int N1=0;int Nc=0;int Nb=0;
 long Y1=0;//переменная хранения значения времени
 long Y2=0;//переменная хранения значения времени
// long C=0;//переменная для обработки данных с пикселя
boolean flag_A=0;//сигнальный флажoк
boolean flag_B=0;//сигнальный флажoк
boolean flag_C=0;//сигнальный флажoк
boolean flag_D=0;//сигнальный флажoк
boolean flag_E=0;//сигнальный флажoк

//byte mas_buf[216]={};//массив для текущего хранения состояния светодиодов куба
byte mas_buf[27]={};//массив для текущего хранения состояния светодиодов куба 
byte massiv_A[N]={};//массив для хранения записанных картинок-кадров
int i=0;//счётчик
int j=0;//счётчик
int l=0;//счётчик
int m=0;//счётчик
int h=0;//счётчик 
int s=0;//счётчик
int p=0;//счётчик
int i1=0;//счётчик
String inputString="";//переменная хранения строки
char KOM=' ';//переменная хранения команд для приложения смартфона

////////////////////////////////////////////
PS2 mouse(4, 5);//к Pin 5 -  подключена линия Data (оранжевый провод), а к pin 4 – линия Clock (белый провод),Vcc - синий, GND- зелёный
  int mstat;//значение указывает на состояние кнопок и направление движения или покоя мыши
  int mx;//приращение координаты x
  int my;//приращение координаты y
  int mz;//приращение координаты z
  char IM_mouse_flag = 0; // флаг, что у нас включено расширение Intellimouse

//////////////////////////////////////////////////////////////
void mouse_init()
{
  mouse.write(0xff);  // reset
  mouse.read();  // ack byte
  mouse.read();  // blank */
  mouse.read();  // blank */
  mouse.write(0xf0);  // remote mode
  mouse.read();  // ack
  delayMicroseconds(100);
}
///////////////////////////////////////////////////////////////
LedControl LC = LedControl(9,6);// создаём объект класса для 6 индикаторов
// при этом выводы 11-DIN 13-CLK 9-CS //
///////////////////////////////////////////////////////////////
void setup()
{
  ///////////////////////
  pinMode(6,INPUT);
 if(digitalRead(6)==HIGH){flag_D=1;}else{flag_D=0;}//условие переключения редактора (0) на исполнителя (1)
  //////////////////////
 for(i=0;i<N;i++){massiv_A[i]=255;}//начальное заполнение массива
  Serial.begin(9600);
  mouse_init();
  SD.begin(PIN_CS);
  for (i=0;i<=5;i++)
   {  
  LC.shutdown(i, false);//выключаем энергосберегающий режим
  LC.setIntensity(i,4 );// устанавливаем интенсивность в 4 единиц между 0 и 15
  LC.clearDisplay(i);//очищаем матрицу i
   }
  ///////////////////////////////////////////
   // Посылаем 200, 100, 80
  mouse.write(0xF3); // set sample rate to...
  mouse.write(200);  // 200
  mouse.read();      // ignore ack
  mouse.write(0xF3); // set sample rate to...
  mouse.write(100);  // 100
  mouse.read();      // ignore ack
  mouse.write(0xF3); // set sample rate to...
  mouse.write(80);   // 80
  mouse.read();      // ignore ack

  mouse.write(0xF2); // get device ID
  mouse.read();      // ignore ack
  IM_mouse_flag = (mouse.read() == 0x03); // если подключена мышь с колёсиком
 
}

//////////////////////////////////////////////////////////////
void loop()
{
  if(flag_D==1)//если режим исполнитель
  {
   
      for(p=0;;p++)//верхний предел для p, например, 10 (по числу эффектов в файле на карте)
  {
        funkz_ispolnitel_SD (p);//загрузить эффект под номером p
metka3: funkz_proigr (5);//повторить 5 раз
        if(flag_C==1){goto metka3;}//условие зацикливания одного и того же эффекта
  }
    }
  else {funkz_cursor();//иначе режим редактор
  if(millis()-Y2>15000&&KOM!='A'){Y2=millis();KOM='A';Serial.println("A");}//условие на RIS0-0
  }
}

///////////////////////////////////////////////////////////////////
void funkz_moise ()//функция запроса данных от мышки 
{
  mouse.write(0xeb);  // команда на чтение данных
  mouse.read();      //  игнорируем ack
  mstat = mouse.read();//например,когда мышь неподвижна и кнопки отпущены значение равно 8, при движении по четвертям принимает значения 8,24,40,56
  mx = mouse.read();if(mx>127){mx=mx-255;}//меняется в диапазоне -127 +127
  my = mouse.read();if(my>127){my=my-255;}//меняется в диапазоне -127 +127
  if(IM_mouse_flag)
  mz = mouse.read();if(mz>7){mz=mz-255;}//меняется в диапазоне -7 +7 
  }
/////////////////////////////////////////////////////////////////
 void funkz_cursor ()//функция движения - рисования курсором
 {
funkz_moise ();
 if(mstat==9||mstat==25||mstat==41||mstat==57){flag_A=1;if(KOM!='C'){KOM='C';Serial.println("C");}}//(условие на RIS0-2)
 //if(flag_A==1){ LC.setLed(z, x, y,1);N1=x+k1*y+k1*k1*z;mas_buf[N1]=1; }//если левая кнопка кратко нажата курсор оставляет след
// if(flag_A==0) { LC.setLed(z, x, y,0);N1=x+k1*y+k1*k1*z;mas_buf[N1]=0; }// иначе гашение предыдущего положения курсора
 if(flag_A==1){ LC.setLed(z, x, y,1);N1=x+k1*y+k1*k1*z;Nc=N1/8;Nb=N1-Nc*8;bitWrite(mas_buf[Nc],Nb,1); }//если левая кнопка кратко нажата курсор оставляет след - ИЗМЕНЕНИЕ ЧЕТВЁРТОЕ
 if(flag_A==0) { LC.setLed(z, x, y,0);N1=x+k1*y+k1*k1*z;Nc=N1/8;Nb=N1-Nc*8;bitWrite(mas_buf[Nc],Nb,0); }// иначе гашение предыдущего положения курсора
 ////////////////////
 //bitRead(x, n)  bitWrite(x, n, b)
  ///////////////////
  if(mx>15){z++;if(z>5){z=5;}if(KOM!='B'){KOM='B';Serial.println("B");}} if(mx<-15){z--;if(z<0){z=0;}if(KOM!='B'){KOM='B';Serial.println("B");}}//условия присвоения новых значений координат курсора по приращениям (условие на RIS0-1)
  if(my<-15){y++;if(y>5){y=5;}if(KOM!='B'){KOM='B';Serial.println("B");}} if(my>15){y--;if(y<0){y=0;}if(KOM!='B'){KOM='B';Serial.println("B");}}//координат от мыши (ориентация осей z и x систем координат разная)
  if(mz<0){x++;if(x>5){x=5;}if(KOM!='D'){KOM='D';Serial.println("D");}} if(mz>0){x--;if(x<0){x=0;}if(KOM!='D'){KOM='D';Serial.println("D");}}//(условие на RIS0-3)
  ///////////////////
  if(mx>15||mx<-15||my>15||my<-15||mz>0||mz<0){flag_A=0;}
  LC.setLed(z, x, y,1);  //включение нового положения курсора 
  ///////////////////////////////////////////
  if(mstat==10||mstat==26||mstat==42||mstat==58){if(KOM!='F'){KOM='F';Serial.println("F");}funkz_zapis ();}//загрузка текущего кадра в массив по нажатию правой кнопки (условие на RIS0-5)
 
  
  if(mstat==12){if(KOM!='E'){KOM='E';Serial.println("E");}funkz_ispol ();}//воспроизведение кадров из массива по нажатию средней кнопки-колеса (условие на RIS0-4)
 
  
  if(mstat==11||mstat==27||mstat==43||mstat==59){if(KOM!='G'){KOM='G';Serial.println("G");}funkz_zapis_SD ();}//запись массива кадров на SD карту по нажатию дублем левой и правой кнопки (условие на RIS0-6)

  
  ///////////////////////////////////////////
  delay(n);//регулировка чуствительности мыши  
 
 }
////////////////////////////////////////////////////////////////
void funkz_ispol ()//функция проигрывания записанных картинок-кадров из массива
{
  
  funkz_ekran();//очистка матриц куба,выключаем все светодиоды
  for(j=0;j<N;j++)
  {
  if(massiv_A[j]<216){N1=massiv_A[j];z=N1/(k1*k1);y=(N1-k1*k1*z)/k1;x=N1-k1*k1*z-k1*y;LC.setLed(z, x, y,1);}
  if(massiv_A[j]==227)
  {
   delay(n); funkz_ekran();//выключаем все светодиоды 
  }
  if(massiv_A[j]==255){break;}
  }
   x=0;y=0;z=0;//возвращение курсора в исходную точку
  }
  //////////////////////////////////////////////////////////////
  void funkz_zapis ()//функция записи текущей картинки-кадра
  {
   
   for(i=0;i<216;i++)//ИЗМЕНЕНИЕ ЧЕТВЁРТОЕ
   {
    Nc=i/8;Nb=i-Nc*8;
    //if(mas_buf[i]==1){massiv_A[l]=i;l++;if(l>N-1){l=0;}mas_buf[i]=0;}
     if(bitRead(mas_buf[Nc],Nb)==1){massiv_A[l]=i;l++;if(l>N-1){l=0;}bitWrite(mas_buf[Nc],Nb,0);}
   }
   massiv_A[l]=227;l++;if(l>N-1){l=0;}// окончание кадра - число 227
   funkz_ekran(); x=0;y=0;z=0;//обновление картинки и возвращение курсора в исходную точку
  }
  /////////////////////////////////////////////////////////////
  void funkz_zapis_SD ()//функция записи массива кадров на карту памяти
  { 
     m=0;//счётчик числа элементов массива
   if(massiv_A[0]!=255){
    myFile = SD.open("DANMAS.txt", FILE_WRITE);
   if(myFile)
   {
   
    while(massiv_A[m]!=255)//пока не дошли до конца данных по пикселям
    {
      if(massiv_A[m]<216){myFile.print(massiv_A[m]);myFile.print(',');}
      if(massiv_A[m]==227){myFile.print(massiv_A[m]);myFile.print('\n');}
      m++; 
    }
    myFile.print(255);myFile.print('\n');//символы завершения набора кадров одного эффекта
     myFile.close(); 
   }
   }
   //////////////////////////////////////////////////////////////////////////
   for(i=0;i<N;i++){massiv_A[i]=255;}l=0;//очистка или начальное заполнение массива программы после записи на карту
  }
  /////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////
  void funkz_moise_ISPOL ()//функция запроса данных от мышки в режиме исполнитель 
{
  mouse.write(0xeb);  // команда на чтение данных
  mouse.read();      //  игнорируем ack
  mstat = mouse.read();//например,когда мышь неподвижна и кнопки отпущены значение равно 8, при движении по четвертям принимает значения 8,24,40,56
  mx = mouse.read();if(mx>127){mx=mx-255;}//меняется в диапазоне -127 +127
  my = mouse.read();if(my>127){my=my-255;}//меняется в диапазоне -127 +127
  if(IM_mouse_flag)
  mz = mouse.read();if(mz>7){mz=mz-255;}//меняется в диапазоне -7 +7 
  ///////////////////////////////////////////////
 
  if (mstat==9){n=n+1;if(n>500){n=500;}if(KOM!='J'){KOM='J';Serial.println("J");}}//левая кнопка - медленнее скорость переключения (условие на RIS1-1)
  if (mstat==10){n=n-1;if(n<20){n=20;}if(KOM!='K'){KOM='K';Serial.println("K");}}//правая кнопка - быстрее скорость переключения (условие на RIS1-2)
  if (mstat==11||mstat==27||mstat==43||mstat==59){flag_C=!flag_C;delay(500);if(KOM!='L'){KOM='L';Serial.println("L");}}//дубль нажатие левой и правой кнопки мыши - смена режима исп.эфф. (ТРЕТЬЕ ИЗМЕНЕНИЕ С ПРЕДЫДУЩЕЙ ВЕРСИЕЙ)
  if(mz>0){p--;if(p<0){p=-1;}if(KOM!='V'){KOM='V';Serial.println("V");}delay(500);}//(условие на RIS1-6) 
  if(mz<0){p++;if(KOM!='X'){KOM='X';Serial.println("X");}delay(500);}//вращение колеса - переход вперёд или назад в исполнении эффектов (ВТОРОЕ ИЗМЕНЕНИЕ С ПРЕДЫДУЩЕЙ ВЕРСИЕЙ)(условие на RIS1-5)
  
  if (mstat==12){if(KOM!='Z'){KOM='Z';Serial.println("Z");}delay(3000);}//стоп-кадр или пауза на 3 секунды (условие на RIS1-4)
  delay(10);// задержка при опросе мышки (ПЕРВОЕ ИЗМЕНЕНИЕ С ПРЕДЫДУЩЕЙ ВЕРСИЕЙ)
  }
/////////////////////////////////////////////////////////////////
  void funkz_ispolnitel_SD (int st)//функция чтения файла с карты в массив программы 
  {
   for(i=0;i<N;i++){massiv_A[i]=255;}// начальное заполнение массива программы для чтения с карты
   i=0;// обнулили значение счётчика
   s=0;// обнулили значение счётчика
   flag_A=0;//взведение флага
   myFile = SD.open("DANMAS.txt");
   if (myFile) {
    while (myFile.available()) {
  ////////////////////////////////
  METKA://ИЗМЕНЕНИЕ ПЯТОЕ (названия эффектов текстом в файле данных можно писать- /эффект волна например/ )
  char inChar = (char)myFile.read();
  if (inChar=='/'){flag_E=!flag_E;if(flag_E==0){inChar = (char)myFile.read();}}
  if(flag_E==1){goto METKA;}
  ////////////////////////////////
  if(flag_E==0){
    if (inChar==','||inChar=='\n'){//если считали символ запятой или переноса строки...
     int perem=inputString.substring(0).toInt();//...преобразовали и занесли в массив предшествующее число
     ////////////////////////////////
     
     if (i>=N){goto metka;}
     if (s==st&&flag_A==0){flag_A=1;}
     if(flag_A==1){massiv_A[i]=(byte)perem;if (massiv_A[i]==255){goto metka;}i++;}
     if(perem==255){s++;}
     
     inputString="";// обнулили переменную 
     ////////////////////////////////
    }
    else {
     inputString += inChar;//пишем цифры символами в переменную 
    }
    }
  
    }
    p=-1;//условие зацикливания исполнений неограниченного числа эффектов в файле
  metka: myFile.close();
   }
   
  }
  /////////////////////////////////////////////////////////////
  void funkz_proigr (int v)//повторение эффекта v раз
{
 if(millis()-Y2>15000&&KOM!='H'){Y2=millis();KOM='H';Serial.println("H");}//условие на RIS1-0
  h=0;//
  while (h<v)//условие числа повторений одного эффекта
  {
  for(i=0;i<N;i++)
   {
     if(massiv_A[i]==255){h++;break;}
      if(massiv_A[i]==227){ delay_(n); funkz_ekran();}
      if (massiv_A[i]!=227&&massiv_A[i]!=255){N1=massiv_A[i];z=N1/(k1*k1);y=(N1-k1*k1*z)/k1;x=N1-k1*k1*z-k1*y;LC.setLed(z, x, y,1);}
    } 
  }
 
}
 //////////////////////////////////////////////////////////////////////////////////////////////////////
 ////  ФУНКЦИИ ОПИСАНИЕ // вместо задержки времени через delay  ///////////////////////////////////////
void delay_(int T1)
{
long Y=millis();
flag_B=1;
 while(millis()-Y<T1) 
  {
  if(flag_B==1){funkz_moise_ISPOL ();if(mstat!=8){flag_B=1;}}//если мышь побескоили 
  }
}
 ///////////////////////////////////////////////////////////////////////////////////////////////////////
void funkz_ekran()// функция очистки слоёв куба
  {
     for (i1=0;i1<=5;i1++)
   {  
    LC.clearDisplay(i1);//очищаем матрицу i
   }
    }
  ///////////////////////////////////////////////////////////// 
